<?php

  class sml_data_source_groupes extends mw_data
  {

    function init_groupe_status(){
      return true;
    }

    function source_groupes($id_source)
    { $env = $this->env();
      $sgbd = $this->sgbd();
      try{
        $sql =
         "SELECT #--sml_authors.*"
         .", #--sml_sources_authors.id_sources_access as id_groupe_status"
        ." FROM #--sml_authors, #--sml_sources_authors"
        ." WHERE #--sml_sources_authors.id_author=#--sml_authors.id"
        ." AND #--sml_sources_authors.id_source=".$this->eq($id_source);
        $rst = $sgbd->query($sql);
        $groupes = array();
        while($v_rst = $sgbd->fetch_assoc($rst))
        { $v_rst["image_uri"] =
          ( $v_rst["image"] ?
            $env->path("content")."uploads/".$v_rst["image"]
            : ""
          );
          $groupes[$v_rst["id"]] = $v_rst;
        }
        $sgbd->free_result($rst);
      }
      catch(Exception $e) { return false; }
      return $groupes;
    }

    function add_source_groupe($id_source, $id_groupe, $id_groupe_status)
    { $sgbd = $this->sgbd();
      try{
        $sql =
         "INSERT INTO #--sml_sources_authors(id_source, id_author, id_sources_access) VALUES"
        ."( ".$this->eq($id_source)
        .", ".$this->eq($id_groupe)
        .", ".$this->eq($id_groupe_status)
        .")";
        $sgbd->query($sql);
      }
      catch(Exception $e) { return false; }
      return true;
    }

    function set_source_groupe($id, $id_groupe_status)
    { if(($groupe = $this->groupe($id)) !== false)
      { $sgbd = $this->sgbd();
        try{
          $sql =
           "UPDATE #--sml_sources_authors SET"
          ."  id_sources_access=".$this->eq($id_groupe_status)
          ." WHERE id=".$id;
          $sgbd->query($sql);
        }
        catch(Exception $e) { return false; }
        return true;
      }
      return false;
    }

    function del_source_groupes($id_source)
    { $sgbd = $this->sgbd();
      try{
        $sql = "DELETE FROM #--sml_sources_authors WHERE id_source=".$this->eq($id_source);
        $sgbd->query($sql);
      }
      catch(Exception $e) { return false; }
      return true;
    }

    function del_source_groupe($id)
    { $sgbd = $this->sgbd();
      try{
        $sql = "DELETE FROM #--sml_sources_authors WHERE id=".$this->eq($id);
        $sgbd->query($sql);
      }
      catch(Exception $e) { return false; }
      return true;
    }

// --------------------------------------------------------------------

    function id_groupe_status_admin()        { return 1; }
    function id_groupe_status_editeur()      { return 2; }
    function id_groupe_status_contributeur() { return 3; }

    function get_admin_groupe($groupes)
    { $groupe = array();
      if(is_array($groupes)) foreach($groupes as $source_groupe)
      { if($source_groupe["id_groupe_status"] == $this->id_groupe_status_admin())
        { $groupe = $source_groupe;
          break;
        }
      }
      return $groupe;
    }

    function source_permissions($source, $id_user)
    { $permissions = array
      ( "admin" => false,
        "editeur" => false,
        "contributeur" => false
      );
      foreach($source["groupes"] as $id_groupe => $source_groupe)
      { if($source_groupe["id_user"] == $id_user)
        { if($source_groupe["id_groupe_status"] == $this->id_groupe_status_admin())
          { $permissions["admin"] = true;
            $permissions["editeur"] = true;
            $permissions["contributeur"] = true;
          }
          elseif($source_groupe["id_groupe_status"] == $this->id_groupe_status_editeur())
          { $permissions["editeur"] = true;
            $permissions["contributeur"] = true;
          }
          elseif($source_groupe["id_groupe_status"] == $this->id_groupe_status_contributeur())
          { $permissions["contributeur"] = true;
          }
        }
      }
      return $permissions;
    }

  }

?>